<%
'****************************************************
'* GCA.ASP by A.Cunnington & J.Fitzgerald
'* this script reads a GURPS character assistant
'* datafile and displays it as an html page
'* Last modified: 27/Nov/1998
'* Note: cga files must be version 2 or greater
'****************************************************
'* based on gcatohtm.pl by Tim Hall, timjh@csi.com
'****************************************************
'* Usage: gca.asp?file=fred.gca&path=\data&portrait=N
'* where file - gca file including the extension. This
'* must be specified.
'* path - virtual path to file in server. This defaults
'* to \cgi-bin
'* portrait - show portrait Y/N. Default is Y
'* Options may by passed on command line or from a Form.
'* Note: portrait files must reside in the same directory
'* as the gca datafile.

'****************************************************
'* Declare global variables
'****************************************************

Dim psecs 'Static array defining sections to print, and the format in which to print them
Set psecs = CreateObject("Scripting.Dictionary")
psecs.Add "General","N"
psecs.Add "Race","N"
psecs.Add "Points","N"
psecs.Add "Stats","Y"
psecs.Add "Advantages","Y"
psecs.Add "Disadvantages","Y"
psecs.Add "Quirks","Y"
psecs.Add "Powers","Y"
psecs.Add "Skills","Y"

Dim pstats 'Static array defining which attributes to print
Set pstats = CreateObject("Scripting.Dictionary")
pstats.Add "ST","Y"
pstats.Add "DX","Y"
pstats.Add "IQ","Y"
pstats.Add "HT","Y"

Const ForReading = 1, ForWriting = 2
Dim buffer 'line read in from file
Dim fso, InputFile, Path, vPath, gcaFile, ImageFile, ShowPortrait
Dim section, headprint, firsthead, footer
Const MinVer = 2 'minimum cga file format supported
Dim Finish
Finish = 0 'If set then don't process further
CRLF = Chr(13) & Chr(10)

'****************************************************
'* Read command line settings
'****************************************************
If Request.ServerVariables("REQUEST_METHOD") = "POST" then
    gcaFile = Request.Form("file")
    vPath = Request.Form("path")
    ShowPortrait = Request.Form("portrait")
Else
    gcaFile = Request.Querystring("file")
    vPath = Request.Querystring("path")
    ShowPortrait = Request.Querystring("portrait")
End If
' Defaults
If (gcaFile = "") then  'no file to show!
    response.write "<p>No GCA file specified!</p>"
    Finnish = -1
End If
If (vPath = "") then    'no file path specified
    vPath = "\cgi-bin" 'set logical location of cga files on web server
End If
If (ShowPortrait = "") then 'Show portrait option not specified
    ShowPortrait = "Y" 'Show it anyway!
End If

Path = Server.MapPath(vPath) & "\"
gcaFile = Path & gcaFile

'****************************************************
'* Declare variables containing HTML formatting code
'****************************************************
' Code placed at the beginning and end of the entire file.
hPageBeg = "<HTML><HEAD><TITLE>Disply GCA file</TITLE></HEAD><BODY>"
hPageFin = "</BODY></HTML>"

' Code placed around the character's name
hNameBeg = "<H3>"
hNameFin = "</H3>"

' Code placed around the character's portrait
hImageBeg = "<IMAGE SRC="""
hImageFin = """ BORDER=""0"" ALIGN=""RIGHT"" ALT=""Character portrait""></IMAGE>"

' Code placed around footnote credits
hFootBeg = "<FONT SIZE=""-1"">"
hFootFin = "</FONT>"

' HTML tags to be placed around the main body of the character sheet.
' I've made this a definition list.
hSheetBeg = "<DL>"
hSheetFin = "</DL>"

' Code placed around each section header
hHeadBeg = "<B><DT>"
hHeadFin = "</B><DD>"

' Code placed around each item within a section
hItemBeg = ""
hItemFin = "<BR>"

'****************************************************
'* Begin
'****************************************************

response.write hPageBeg & CRLF

' Open the file and read it
Set fso = CreateObject("Scripting.FileSystemObject")
Set InputFile = fso.OpenTextFile(gcaFile, ForReading)

firsthead="Yes"
Do
    buffer = Trim(InputFile.ReadLine)

    If (left(buffer,1) = "[") AND (right(buffer,1) = "]") then 'found a new section
        section = mid(buffer, 2, len(buffer)-2)
        headprint = "No"

    ElseIf (section = "System") then
        If (left(buffer, 8) = "version(") AND (right(buffer,1) = ")")then
                version = Cint(mid(left(buffer, len(buffer)-1),9))
                If (version < MinVer) then
                    response.write "<p>Sorry, this file is created with an earlier version"
                    response.write " of GCA (version " & version & "). This script will only"
                    response.write " work with files of version " & MinVer & " or higher.</p>"
                    Finish = -1 'set flag, this will cause rest of execution to end
                End If
        End if

    ElseIf (section = "System Notes") then
        footer = footer & buffer & "<BR>" & CRLF

    ElseIf (buffer <> "" AND psecs.Exists(section)) then
        vals = split(buffer, ",")
        Dim oDic
        Set oDic = CreateObject("Scripting.Dictionary")
        for c = 0 to Ubound(vals)
            line = Trim(vals(c))
            lpos = InstrRev(line, "(", -1, vbTextCompare)
            rpos = InstrRev(line, ")", -1, vbTextCompare)
            while (rpos = 0)
                If (c = Ubound(vals)) Then
                    line = Trim(vals(c)) & ")"
                Else
                    line = Trim(vals(c)) & "," & Trim(vals(c+1))
                End If
                rpos = InstrRev(line, ")", -1, vbTextCompare)
                c = c+1
            wend
            If (lpos = 0) then
                attribute = line
                value = line
            Else
                attribute = Left(line, lpos-1)
                value = Mid(line, lpos+1, rpos-lpos-1)
            End If
            If oDic.Exists(attribute) then
                'do nothing
            Else
                oDic.Add attribute, value
            End If
        Next

        'If this is a new section, then print the section header.

        If (headprint = "No" AND psecs.Item(section) = "Y") then
            If (firsthead = "Yes") then
                firsthead = "No"
                response.write hSheetBeg & CRLF
            End If
            response.write hHeadBeg & section & hHeadFin & CRLF
            headprint = "Yes"
        End If

        If (section = "General") then
            If (oDic.Exists("charname")) Then
                response.write hNameBeg & oDic.Item("charname") & hNameFin & CRLF
            End if
            If (oDic.Exists("description")) Then
                response.write oDic.Item("description") & "<P>" & CRLF
            End If
            If (oDic.Exists("notes")) Then
               response.write oDic.Item("notes") & "<P>" & CRLF
            End If
            If (oDic.Exists("portraitfile") AND ShowPortrait = "Y") Then
                If (oDic.Item("portraitfile") = "") Then
                    'No portrait specified
                Else
                    line = oDic.Item("portraitfile")
                    Imagefile = vPath & "\" & Right(line, Len(line)-InstrRev(line, "\"))
                    If (fso.FileExists(Path & Right(line, Len(line)-InstrRev(line, "\")))) Then
                        response.write hImageBeg & ImageFile & hImageFin & CRLF
                    Else
                        'Portrait file not Found!
                    End If
                End If
            End If
        ElseIf (section = "Points") then
            If (oDic.Exists("total")) then
                response.write oDic.Item("total") & " points, "
            End If
        ElseIf (section = "Race") then
            If (oDic.Exists("name")) then
                response.write oDic.Item("name") & CRLF
            End If
        ElseIf (section = "Stats") then
            If (pstats.Exists(oDic.Item("name"))) then
                response.write hItemBeg & oDic.Item("name") & ": " & oDic.Item("score") & " [" & oDic.Item("points") & "]" & hItemFin & CRLF
            End If
        ElseIf (section = "Skills") then
            response.write hItemBeg & oDic.Item("name")
            if (oDic.Item("nameext") <> "") then
                response.write "(" & oDic.Item("nameext") & ")" & CRLF
            End If
            response.write " -" & oDic.Item("level") & " [" & oDic.Item("points") & "]" & hItemFin & CRLF
        Else
            response.write hItemBeg & oDic.Item("name")
            If (oDic.Item("nameext") <> "") then
                   response.write "(" & oDic.Item("nameext") & ")"
            End If
            If (oDic.Item("level") <> "1") then
                   response.write " " & oDic.Item("level")
            End If
            response.write " [" & oDic.Item("cost") & "]" & hItemFin & CRLF
            End If
        End If

loop until InputFile.AtEndOfStream OR (Finish = -1)
InputFile.close
response.write hSheetFin & CRLF
response.write hFootBeg & footer & hFootFin
response.write hPageFin

%>